// raunanje pi = 4*(1- 1/3 + 1/5 - 1/7 + ....)
// nitke, narobe
// slabo izvedeno zaklepanje. Tvegano stanje smo samo prestavili na spremenljivko lock
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h>

#define N 1000000
#define NTHREADS 13

double pi;
int lock;

void *thread_sum(void *arg)
{
	int i, sign;
	int rank = (int)arg;
	int start = (int)(N/(double)NTHREADS*rank);
	int stop = (int)(N/(double)NTHREADS*(rank+1));

	if( start%2 == 0)
		sign = 1;
	else 
		sign = -1;
	for(i=start; i<stop; i++, sign = -sign)
	{
		while( lock != 0 );
		lock = 1;
		pi += sign*4.0/(2*i+1);
		lock = 0;
	}

	return NULL;
}

int main(void)
{
	int i;
	pthread_t t[NTHREADS];

	pi = 0.0;
	lock = 0;

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, thread_sum, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	printf("pi = %lf\n", pi);

	return 0;
}
