// računanje pi
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h>

#define N 1000000
#define NTHREADS 13

double pi;

void *thread_sum(void *arg)
{
	int i, sign;
	int myrank = (int)arg;
	int mystart = (int)(N / (double)NTHREADS*myrank);
	int myend = (int)(N / (double)NTHREADS*(myrank + 1));
	printf("%d %d %d\n", myrank, mystart, myend);

	pi = 0.0;
	sign = 1;
	for (i = 0; i<N; i++, sign = -sign)
		pi += sign*4.0 / (2 * i + 1);

	return NULL;
}

int main(void)
{
	int i;
	pthread_t t[NTHREADS];

	for (i = 0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, thread_sum, (void *)i);

	for (i = 0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	printf("pi = %lf\n", pi);

	return 0;
}
